<template>
  <v-textarea
    v-model="model"
    :label="label"
    color="primary"
    :variant="variant"
    auto-grow
    :rules="rules"
    :rows="rows"
    base-color="onSurfaceVariant"
    :readonly="readonly"
    hide-details="auto"
    :disabled="disabled"
    :error="error"
    :placeholder="placeholder"
    :counter="counter"
    :persistent-counter="persistentCounter"
    :maxlength="maxLength"
    :messages="messages"
    :error-messages="errorMessages"
    :max-rows="maxRows"
    @update:model-value="update"
  >
    <template v-if="counter && persistentCounter" #counter="{ value }"> {{ (maxLength || 0) - value }} / {{ maxLength }} </template>
  </v-textarea>
</template>

<script setup>
import { ref, watch, onMounted } from 'vue';

const props = defineProps({
  label:{
    type: String,
    default: undefined,
  },
  modelValue:{
    type: String,
    default: '',
  },
  color: {
    type: String,
    default: 'primary',
  },
  variant: {
    type: String,
    default: 'outlined',
  },
  rows: {
    type: Number,
    default: 1,
  },
  maxRows: {
    type: Number,
    default: undefined,
  },
  error: {
    type: Boolean,
    default: false,
  },
  disabled: {
    type: Boolean,
    default: false,
  },
  counter: {
    type: Boolean,
    default: false,
  },
  readonly: {
    type: Boolean,
    default: false,
  },
  persistentCounter: {
    type: Boolean,
    default: false,
  },
  maxLength: {
    type: Number,
    default: undefined,
  },
  messages: {
    type: String,
    default: undefined,
  },
  placeholder: {
    type: String,
    default: undefined,
  },
  errorMessages: {
    type: String,
    default: undefined,
  },
  rules: {
    type: Array,
    default: () => [],
  }
})

const emit = defineEmits(['update:modelValue', 'clear'])

onMounted(() => {
  model.value = props?.modelValue
});

const model = ref(null);

const update = () => {
  emit('update:modelValue', model?.value)
}

watch(props, (newValue, oldValue) => {
  if (newValue?.modelValue) {
    model.value = newValue?.modelValue
  }
})
</script>